/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package cheminzlib;

/**
 * Třída čerpadla kapalin v proudu jako element
 * @author V. Hlubuček
 */
public class Cerpadlo extends Element {

    protected double hmotPr;          // hmotový průtok dodaný čerpadlem
    protected double rozdilTlaku;     // rozdíl tlaků dodaný čerpadlem
/**
 * Konstruktor čerpadla
 * @param pr proud do čerpadla
 * @param nazElementu 
 */    
    public Cerpadlo(Proud pr, String nazElementu) {
        super();
        this.pr = pr;
        this.nazElementu = nazElementu; 
        myInit();        
    }
/**
 * Bezparametrový konstruktor čerpadla
 */
    public Cerpadlo() {
        super();
        this.nazElementu = "Čerpadlo"; 
        myInit();          
    }
/**
 * Inicializace elementu trubka
 * popis labelů a default hodnot pro interaktivní zadávání
 */
    public void myInit() {
        lTexty = new String[6];
        tValue = new String[6];
        lTexty[0] = "Čerpadlo";
        lTexty[1] = "Hm. průtok (kg/s)";
        lTexty[2] = "Rozdíl tlaků(kPa)";
        lTexty[3] = "";
        tValue[1] = "0,5";
        tValue[2] = "1";      // kPa
//        tValue[3] = "0,0005";
        
    }
/**
 * Dosadí do proměnných hodnoty z interaktivního zadání
 */ 
    @Override
    public void dosadInteraktivniHodnoty() {
        hmotPr = doubleFromString(tValue[1]);
        rozdilTlaku = doubleFromString(tValue[2])*1000;
//        drsnost = doubleFromString(tValue[3]);
    }

    @Override
    public double tlakZtrata() {
        report = "Čerpadlo " + nazElementu + "\n";
        if(rozdilTlaku > 0) report += " zvýší tlak o " + rozdilTlaku/1000 + "(kPa)\n";        
        if(pr.hmotPrutok <= 0) pr.hmotPrutok = hmotPr;  else hmotPr = pr.hmotPrutok;
        if(hmotPr > 0) report += " hmot.průtok    " + hmotPr + "(kg/s)\n";
        return -rozdilTlaku;
    }

    @Override
    public String vysledkyElement() {
        return report;
    }

// Gettery a settery -------------------------------------------------
    /**
     * Vrací rozdíl tlaku dodaný čerpadlem
     * @return 
     */
    public double getRozdilTlaku() {
        return rozdilTlaku;
    }
    /**
     * Nastavuje  rozdíl tlaku dodaný čerpadlem
     * @param rozdilTlaku 
     */
    public void setRozdilTlaku(double rozdilTlaku) {
        this.rozdilTlaku = rozdilTlaku;
    }

     
}
