/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package cheminzlib;

import fydat.FydatGUI;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileNameExtensionFilter;

/**
 * Třída modálního vyskakovacího panelu pro zobrazení obecných výsledků.
 * Volat jako:<br>  JDialogReport frmProud = new JDialogReport(null, "muj proud", myProud);
 * @author V. Hlubuček
 */
public class JDialogReport extends javax.swing.JDialog {
    
    String titulek = " Dialog pro zobrazení proudu";
    String report;

    /**
     * Creates new form JDialogReport
     */
    public JDialogReport(java.awt.Frame parent,  String title, String report) {
        super(parent, true);
        initComponents();
        this.report = report;
        jTextArea1.setText(report); 
        this.setTitle(title);
        this.setVisible(true);        
    }
/**
 * Uložení reportu do souboru
 */
    protected void doSouboru() {
        int i;
        String curDir, filenam, vysledek, kodovani = "Cp1250";
        File soubor;
        JFileChooser fc;
        FileOutputStream fout = null;
        OutputStreamWriter osw;
        PrintWriter opw = null;
        vysledek = report;
        
        Object[] moznosti = {"Windows Cp1250", "UTF-8", "Linux ISO8859-2"};
        String s = (String)JOptionPane.showInputDialog(
                            this,
                            "Zvolte kódovní textu výsledků\n"
                            + "(Windows, UTF-8, Linux)",
                            "Uložení výsledků",
                            JOptionPane.QUESTION_MESSAGE,
                            null,
                            moznosti,
                            "Windows Cp1250");
        if ((s != null) && (s.length() > 0)) {
            if("UTF-8".equals(s)) kodovani = "UTF8"; 
            if("Linux ISO8859-2".equals(s)) kodovani = "ISO8859-2"; 
        } else {
            return;
        }
        if("Cp1250".equals(kodovani)) vysledek = zajistiCRLF(vysledek); // doplní CRLF
        curDir = System.getProperty("user.dir");    // běžný adresář aplikace 
        fc = new JFileChooser(curDir); 
        fc.setFileFilter(new FileNameExtensionFilter("Textový výsledek .txt, .res", "txt","TXT","res"));        
        fc.setDialogTitle("Uložení výsledků");
        fc.setFileSelectionMode(JFileChooser.FILES_ONLY);
        int res = fc.showSaveDialog(this);
        if (res == JFileChooser.APPROVE_OPTION) {
            soubor = fc.getSelectedFile();  
            filenam = soubor.getPath();     // textové plné jméno souboru
            i = filenam.lastIndexOf(".");
            if(i <= 0)filenam +=  ".txt";   // doplnění typu txt
            if(fout == null) {
                try {
                    fout = new FileOutputStream(filenam,true); // režim append souboru
                    osw = new OutputStreamWriter(fout, kodovani);
                    opw = new PrintWriter(osw);
                    opw.format("%s",vysledek);
                    JOptionPane.showMessageDialog(null, "Výsledkové okno uloženo do souboru: "
                        + filenam + "\nKodování " + kodovani ,"Uložení výsledků", 
                        JOptionPane.INFORMATION_MESSAGE);
                } catch (FileNotFoundException ex) {
                    Logger.getLogger(FydatGUI.class.getName()).log(Level.SEVERE, null, ex);
                    ex.getLocalizedMessage();
                } catch (IOException ex) {
                    Logger.getLogger(FydatGUI.class.getName()).log(Level.SEVERE, null, ex);
                    ex.getLocalizedMessage();
                } finally {
                    try {
                        if(fout != null) { opw.close(); fout.close(); }
                    } catch (IOException ex) {
                        Logger.getLogger(FydatGUI.class.getName()).log(Level.SEVERE, null, ex);
                        ex.getLocalizedMessage();
                    }
                }         
            }                         
        }
        
    }
    
    protected String zajistiCRLF(String tx) {
        int i, n;
        char c;
        String txnew = "";
        n = tx.length();
        for(i = 0; i < n; i++) {
            c = tx.charAt(i);
            if(c == '\n' && i > 0) {
                if(tx.charAt(i - 1) != '\r') txnew += '\r';
            }
            txnew += tx.substring(i, i + 1);            
        }
        return txnew;
    }    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        jButtonUloz = new javax.swing.JButton();
        jButtonZavri = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Report");

        jTextArea1.setColumns(20);
        jTextArea1.setFont(new java.awt.Font("Monospaced", 0, 12)); // NOI18N
        jTextArea1.setRows(5);
        jScrollPane1.setViewportView(jTextArea1);

        jButtonUloz.setText("Ulož");
        jButtonUloz.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonUlozActionPerformed(evt);
            }
        });

        jButtonZavri.setText("Zavři");
        jButtonZavri.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonZavriActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 688, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jButtonUloz, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jButtonZavri, javax.swing.GroupLayout.DEFAULT_SIZE, 130, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 425, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(31, Short.MAX_VALUE))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jButtonUloz)
                .addGap(28, 28, 28)
                .addComponent(jButtonZavri)
                .addGap(46, 46, 46))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButtonZavriActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonZavriActionPerformed
        // Zavřít okno reportu
        this.dispose();   // lepší než setVisible(false)
    }//GEN-LAST:event_jButtonZavriActionPerformed

    private void jButtonUlozActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonUlozActionPerformed
        // uloží report do souboru
        doSouboru();
        this.dispose();
    }//GEN-LAST:event_jButtonUlozActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(JDialogReport.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(JDialogReport.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(JDialogReport.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(JDialogReport.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the dialog */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                JDialogReport dialog = new JDialogReport(new javax.swing.JFrame(), "Výpis výsledků","report...\na další výsledky....");
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
//                dialog.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonUloz;
    private javax.swing.JButton jButtonZavri;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextArea jTextArea1;
    // End of variables declaration//GEN-END:variables
}
