/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package cheminzlib;

import java.io.IOException;
import java.util.Arrays;
import javax.swing.JOptionPane;

/**
 * Třída pro převod fyzikálních jednotek
 * @author V. Hlubuček
 */
public class Prevod {
    
    int mocnina, indTypu, zn, chyba; // počet převodů, operativní mocnina převodu
    int var;                        // počet zadaných položek
    long[] typy = new long[2];    // výsledné typy rozměrů pro check konzistence
    boolean nacteno = false, setrideno;
    double cislo;
    String data, txCislo, txZ, txDo;
    String delimiter = "[\\s;]";       // mezera,  středník
    static Konstanty[] kon = new Konstanty[120];
    static int nKonst;
    /**
     * Pomocná vnitřní třída
     */
    class Konstanty implements Comparable {
        String rozmer;
        double prevod;
        long typ;
        public Konstanty(String rozmer, double prevod, long typ) {
            this.rozmer = rozmer;
            this.prevod = prevod;
            this.typ = typ;
        }
        /**
         * Funkce interface Comparable pro porovnávání
         * @param t
         * @return in <0 když menší >0 když větší, 0 stejné
         */
        public int compareTo(Object t) {
            return this.rozmer.compareToIgnoreCase(((Konstanty)t).rozmer);
        }
    }
    
    public Prevod() {
        myInit();
    }
    /**
     * Funkce vrací fyzikální veličinu po převodu dle rozměru jako double
     * @param velicina String <b> DO číslo Z</b><br>
     * kde Z je textově rozměr zadávaného čísla; DO rozměr do kterého chceme převést<br>
     * chybí-li DO převede se z rozměru Z do základních jednotek SI<br>
     * Př: " 15,2 km/h" převede na m/s;  "mi/hr 120 km/h"  převede rychlost na míle za hodinu<br>
     * oddělovač: <b>mezera</b>, případně středník<br>
     * možno použít des. tečku i čásrku<br>
     * kontroluje konzistenci rozměrů Z a DO<br>
     * u rozměrů nezáleží na použití velkých či malých písmen
     * @return převedená hodnota veličiny
     */
    public double hodnota(String velicina) {

        double f, s = 0;
        if(velicina.equals("")) return -7777;
        velicina = velicina.trim();
        data = velicina.replace(",", ".");    // zadaný údaj s rozměrem/ry
        typy[0] = typy[1] = 5444 ; 
        zn = 1;
        chyba = 0;  // vše OK
        txDo = "";
        txZ = "";
        String[] casti = data.split(delimiter, 0);
        txCislo = data;
        var = casti.length;
        try {
            switch (var){
                case 1: txCislo = casti[0]; 
                    int k = txCislo.length();
                    char c = txCislo.charAt(k - 1);
                    if(c >='0' && c <= '9'){
                        return Double.parseDouble(txCislo);   // zadáno přímo číslo
                    } else {
                        doplnMezeru();
                        break;
                    }
                case 2: txCislo = casti[0]; txZ = casti[1]; break;      // převod do SI 
                case 3: txDo = casti[0]; txCislo = casti[1]; txZ = casti[2]; break; // převod Z DO
                default:  break;    // chyba    
            }
        }
        catch (NumberFormatException ex) {
            int input = JOptionPane.showOptionDialog(null, "Patrně chybí oddělovač mezi číslem a rozměrem: " + data 
                    + "\n" + ex.getMessage()+ "\nChcete ukončit program? Pokud ne, Cancel", 
                    "Převod", JOptionPane.OK_CANCEL_OPTION, 
                    JOptionPane.ERROR_MESSAGE, null, null, null);
            if(input == JOptionPane.OK_OPTION) System.exit(0);
            chyba = -1;
            return -9999;            
        }
       
        if(var > 3) return -9999;
        if(var == 1 && txCislo.isEmpty()) return -9999;
        if(var == 2 && (txCislo.charAt(0)<'0' || txCislo.charAt(0)>'9')) {
            txDo = txCislo;
            txCislo = txZ;
            txZ = "";
            if(txDo.toUpperCase().equals("C") || txDo.toUpperCase().equals("F") || 
                txDo.toUpperCase().equals("°C") || txDo.toUpperCase().equals("°F")){
                txZ = "K";  // převod teploty   C 325    nebo  F 348
                txDo = txDo.toUpperCase();
                var = 3;                
            }else {
                String cis = txCislo, txt = txDo;               // převod typu:  km/h 333  
                double pom = hodnota("1 " + txDo);  // tj z SI do nestandardních jednotek
                txDo = txt;
                try {
                return Double.parseDouble(cis)/ pom;
                } 
                catch (NumberFormatException ex) {
                String[] var = {"Ukončit", "Pokračovat"};    
                int input = JOptionPane.showOptionDialog(null, "S rozměry nebyl zadána číselná hodnbota: " + txDo + " " + txZ 
                        + "\n" + ex.getMessage()+ "\nChcete ukončit program nebo pokračovat?", 
                        "Převod", JOptionPane.OK_CANCEL_OPTION, 
                        JOptionPane.ERROR_MESSAGE, null, var, var[1]);
                if(input == JOptionPane.OK_OPTION) System.exit(0);
                chyba = -3;
                return -9999;                    
                }
            }
        }
        indTypu = 0;        
        if(txCislo.isEmpty()) {
            f = 1;
        } else {
            cislo = Double.parseDouble(txCislo);
            f = dekodujRozmer(txZ);
        }
        if(Math.abs(f - 9999)> 0.05) {
            s = cislo * f;
        } else {  // pouze převod teploty   
            if((txZ.toUpperCase()).equals("°C") || (txZ.toUpperCase()).equals("C")) s = cislo + 273.15;
            if((txZ.toUpperCase()).equals("K") ) s = cislo;
            if((txZ.toUpperCase()).equals("°F") || (txZ.toUpperCase()).equals("F")) s = (cislo - 32) /1.8 + 273.15;
            if((txZ.toUpperCase()).equals("°R") || (txZ.toUpperCase()).equals("R")) s = cislo /1.8;
            txDo = txDo.toUpperCase();
            typy[0] = 5444;
        }
        if(var == 2) return s;
        // požadavek na převod DO
        indTypu = 1;
        f = dekodujRozmer(txDo);
            if(typy[0] != typy[1]) {
            String[] var = {"Ukončit", "Pokračovat"};    
            int input = JOptionPane.showOptionDialog(null, "Nekonzistentní rozměr DO: " 
                    + txDo + "  Z: " + txZ + "\n" + typy[0] + " : " + typy[1]
                    + "\nChcete ukončit program nebo pokračovat?", 
                    "Převod", JOptionPane.OK_CANCEL_OPTION, 
                    JOptionPane.ERROR_MESSAGE, null, var, var[1]);
            if(input == JOptionPane.OK_OPTION) System.exit(0);
            chyba = -1;
            return -9999;             
        }
        if(Math.abs(f - 9999)> 0.05) {
            s = s / f;
        } else {  // pouze převod teploty
            if((txDo.toUpperCase()).equals("°C") || (txDo.toUpperCase()).equals("C")) s = s - 273.15;
            if((txDo.toUpperCase()).equals("K") ) s = s;
            if((txDo.toUpperCase()).equals("°F") || (txDo.toUpperCase()).equals("F")) s = 1.8*(s - 273.15) + 32;
            if((txDo.toUpperCase()).equals("°R") || (txDo.toUpperCase()).equals("R")) s = 1.8 * s;
            typy[1] = 5444;
        }        
        return s;
    }
    /**
     * Dekodování rozměru u čísla
     * @param tx
     */
    protected double dekodujRozmer(String tx) {
        int i, ii, n;
        double s;
        String[] roz = tx.split("[*/]");
        n = roz.length;
        if(n == 1 && typRozmeru(tx) == 5444){
            return 9999;    // pouze převod teploty
        }
        ii = 1;
        zn = 1;
        s =  prevodRozmeru(roz[0]);
        typy[indTypu]= typRozmeru(roz[0]);
        for(i = 1; i < tx.length(); i++) {
           if(tx.substring(i, i+1).equals("*")) {
               s *= prevodRozmeru(roz[ii]);
               zn = 1;
               typy[indTypu]= addTyp(zn, typy[indTypu],typRozmeru(roz[ii]));
               ii++;
           }
           if(tx.substring(i, i+1).equals("/")) {
               s /= prevodRozmeru(roz[ii]);
               zn = -1;
               typy[indTypu]= addTyp(zn, typy[indTypu],typRozmeru(roz[ii]));               
               ii++;
           }
        }
        return s;
    }
    /**
     * Vrací výsledný převodní faktor jednoduchého rozměru
     * @param tx
     * @return 
     */
    protected double prevodRozmeru(String tx) {
        int i, k, n = 0;
        double s = -9999;
        String c;
        mocnina = 1;
        if(!nacteno) myInit();
        // jedná se o mocninu?
        k = tx.length();        
        c = tx.substring(k-1);
        if(c.equals("2") || c.equals("3")  || c.equals("4")) {
            tx = tx.substring(0,k-1);
            n = Integer.parseInt(c);
            mocnina = n;
        }
        for(i = 0; i < nKonst; i++) {
            if((tx.toUpperCase()).equals(kon[i].rozmer.toUpperCase())) {
                s = (n > 0) ? Math.pow(kon[i].prevod, n):kon[i].prevod;
                return s;
            }
        }
        int input = JOptionPane.showOptionDialog(null, "Neznámý rozměr: " + tx
                +  "\nChcete ukončit program?", 
                "Převod", JOptionPane.OK_CANCEL_OPTION, 
                JOptionPane.ERROR_MESSAGE, null, null, null);
        zobrazRozmery();
        if(input == JOptionPane.OK_OPTION) System.exit(0);
        chyba = -2;
        return s;          
    }
    /**
     * Funkce vrací fyzikální veličinu po převodu dle rozměru jako String s rozměrem
     * @param tx String <b> DO číslo Z</b><br>
     * kde Z je textově rozměr zadávaného čísla; DO rozměr do kterého chceme převést<br>
     * chybí-li DO převede se z rozměru Z do základních jednotek SI<br>
     * Př: " 15,2 km/h" přvede na m/s;  "mi/hr 120 km/h"  převede rychlost na míle za hodinu<br>
     * oddělovač: <b>mezera</b>, případně středník nebo i čárka<br>
     * možno použít des. tečku i čásrku<br>
     * kontroluje konzistenci rozměrů Z a DO
     * @return převedená hodnota jako String s rozměrem
     */    
    public String hodnotaDo(String tx) {
        return hodnotaString(tx) + txDo;
    }
    /**
     * Funkce vrací fyzikální veličinu po převodu dle rozměru jako String bez rozměremu
     * @param tx String <b> DO číslo Z</b> nebo <b> číslo Z</b><br>
     * kde Z je textově rozměr zadávaného čísla; DO rozměr do kterého chceme převést<br>
     * chybí-li DO převede se z rozměru Z do základních jednotek SI<br>
     * Př: " 15,2 km/h" přvede na m/s;  "mi/hr 120 km/h"  převede rychlost na míle za hodinu<br>
     * oddělovač: <b>mezera</b>, případně středník nebo i čárka<br>
     * možno použít des. tečku i čásrku<br>
     * kontroluje konzistenci rozměrů Z a DO
     * @return převedená hodnota jako String bez rozměru
     */      
    public String hodnotaString(String tx) {
        double val, aval;
        String res, form;
        txDo = "";
        val = hodnota(tx);
        if(Math.abs(val + 7777) < 0.01) return "";  // dekódován prázdný string
        aval = Math.abs(val);
        form = "%8.5g ";
        res = String.format(form, val);
        return res;        
    }
    /**
     * Vrací typ rozměru jako long (rozměrová analýza)
     * @param tx rozměr textově
     * @return 
     */
    public long typRozmeru(String tx) {
        int i, k, n = 0, moc;
        long typ, typ0;
        double s = -9999;
        String c;
        mocnina = 1;
        if(!nacteno) myInit();
        // jedná se o mocninu?
        k = tx.length();        
        c = tx.substring(k-1);
        if(c.equals("2") || c.equals("3")  || c.equals("4")) {
            tx = tx.substring(0,k-1);
            n = Integer.parseInt(c);
            mocnina = n;
        }        
        for(i = 0; i < nKonst; i++) {
            if((tx.toUpperCase()).equals(kon[i].rozmer.toUpperCase())) {
                typ0 = kon[i].typ;
                typ = typ0;
                if(mocnina == 1) return typ;
                moc = mocnina;
                // účelové snížení mocniny
                if(zn > 0) mocnina--;  else mocnina = mocnina +1;  
                typ = addTyp(zn, typ, typ0);
                mocnina = moc;
                return typ;
            }
        }
        return -9999;
    }
    /**
     * Vrací ind-tou cifru proměnné typ
     * @param typ
     * @param ind
     * @return 
     */
    protected int poziciTypu(long typ, int ind) {
        int moc, res = -9999;
        if(ind == 0) {
            res = (int)(typ % 10);
        } else {
            moc = (int)Math.pow(10,ind + 1);
            res = (int)(typ % moc);
            res = res / (moc/10);
        } 
        return res;
    } 
    /**
     * Přidá k celkovému typu typ rozměru
     * @param zn    >0 násobení; <0 dělení
     * @param typCelk  celkový typ složeného rozměru
     * @param typ   typ zpracovávaného jednoduchého rozměru
     * @return typCelk po promítnutí
     */
    protected long addTyp(int zn, long typCelk, long typ) {
        int i,nC, n, k;
        long d,typNew = typCelk;
        zn = (zn > 0)? 1: -1;
        for(i = 0; i < 7; i++) {
           nC = poziciTypu(typCelk, i);     // číslice typů
           n = poziciTypu(typ, i);          
           if(n == 0)break;        // jednotkový rozměr nemá tyto "řády" if(n == 0 && nC == 0)break;
           if(n == 4)continue;     // veličina není součástí jedn. rozměru
           k = mocnina;
           if(k == 1 && n > 5) k = k + n - 5;           
           d = (long)(zn * k * Math.pow(10, i)); // navýšení nebo ubrání cifry
           if(nC == 0 && d < 0) d = -3*d;
           typNew = typNew + d; // navýšení nebo ubrání cifry
        }
        return typNew;
    }
    /**
     * Zobrazí v okně dostupné zkratky rozměrů
     */
    public void zobrazRozmery() {
        if(!setrideno) {Arrays.sort(kon, 0, nKonst); setrideno = true; }       
        JDialogPrevod jdp = new JDialogPrevod(null, true, kon );
    }
    
    protected void doplnMezeru() {
        int i;
        char c;
        for(i = 0; i < txCislo.length(); i++) {
            c = txCislo.charAt(i);
            if(c >= 'A' && c <= 'z') break;
        }
        txZ = txCislo.substring(i);
        txCislo = txCislo.substring(0, i );
        var = 2;
    }
    /**
     * Vrací i-tý rozměr
     * @param i
     * @return rozměr
     */
    public String getRozm(int i) {
        return kon[i].rozmer;
    }
    /**
     * Vrací poslední zadaný rozměr
     * @return 
     */
    public String getRozm() {
        return txZ;
    }
    /**
     * Vrací i-tý typ rozměru
     * @param i
     * @return typ
     */
    public long getTyp(int i) {
        return kon[i].typ;
    } 
    /**
     * Vrací počet existujících převodů
     * @return 
     */
    public int getPocetPrevodu() {
        return nKonst;
    }
    /**
     * Inicializace proměnných
     */
    final void myInit() {
    // Typ:  řády odpovídají mocninám jednotlivých veličin + 4
    //     x  cd mol A  K kg  s  m
    //     7   6  5  4  3  2  1  0
    //   délka   5       plocha  6       objem   7
    //   čas     54      hmota   544     síla    525
    //   tlak    523     energie 526     výkon   516
    //   viskoz. 533     rychlost 36     
    //  Chybové stavy : 0-vše v pořádku); 1-nekonzistentní jednotky ); 2-neznámý rozměr
        nKonst = 111;        // počet převodů
    if(kon == null || !nacteno) { 
        kon[0] = new Konstanty("?",-999,-999);
        kon[1] = new Konstanty("m",1, 5);      
        kon[2] = new Konstanty("dm", 0.1, 5);        
        kon[3] = new Konstanty("cm", 0.01,5);        
        kon[4] = new Konstanty("mm", 0.001, 5);       
        kon[5] = new Konstanty("km", 1000, 5);       
        kon[6] = new Konstanty("nm", 1e-9, 5);        
        kon[7] = new Konstanty("s", 1, 54);        
        kon[8] = new Konstanty("min", 60, 54);       
        kon[9] = new Konstanty("hod", 3600, 54);        
        kon[10] = new Konstanty("den", 86400, 54);       
        kon[11] = new Konstanty("rok", 31557600, 54);        
        kon[12] = new Konstanty("ms", 0.001, 54);        
        kon[13] = new Konstanty("ns", 1e-9, 54);        
        kon[14] = new Konstanty("kg", 1, 544);       
        kon[15] = new Konstanty("g", 0.001, 544);        
        kon[16] = new Konstanty("dkg", 0.1, 544);       
        kon[17] = new Konstanty("q", 100, 544);       
        kon[18] = new Konstanty("t", 1000, 544);  
        kon[19] = new Konstanty("K", 1, 5444);       
        kon[20] = new Konstanty("C", 1, 5444);  
        kon[21] = new Konstanty("F", 0.555555556, 5444);      
        kon[22] = new Konstanty("R", 0.555555556, 5444);       
        kon[23] = new Konstanty("ar", 100, 6);       
        kon[24] = new Konstanty("ha", 10000, 6);  
        kon[25] = new Konstanty("l", 0.001, 7);  
        kon[26] = new Konstanty("dcl", 0.0001, 7);  
        kon[27] = new Konstanty("Pa", 1, 523); 
        kon[28] = new Konstanty("kPa", 1000, 523); 
        kon[29] = new Konstanty("MPa", 1e6, 523);  
        kon[30] = new Konstanty("atm", 98066.5, 523);  
        kon[31] = new Konstanty("torr", 133.322, 523); 
        kon[32] = new Konstanty("mmH2O", 9.78899, 523); 
        kon[33] = new Konstanty("mmvs", 9.78899, 523); 
        kon[34] = new Konstanty("J", 1, 526); 
        kon[35] = new Konstanty("kJ", 1000, 526); 
        kon[36] = new Konstanty("MJ", 1e6, 526);  
        kon[37] = new Konstanty("GJ", 1e9, 526);   
        kon[38] = new Konstanty("TJ", 1e12, 526); 
        kon[39] = new Konstanty("cal", 4.1868, 526); 
        kon[40] = new Konstanty("kcal", 4186.8, 526);  
        kon[41] = new Konstanty("kWh", 3.6e6, 526); 
        kon[42] = new Konstanty("W", 1, 516);  
        kon[43] = new Konstanty("kW", 1000, 516);  
        kon[44] = new Konstanty("MW", 1e6, 516); 
        kon[45] = new Konstanty("GW", 1e9, 516);   
        kon[46] = new Konstanty("TW", 1e12, 516);       
        kon[47] = new Konstanty("N", 1, 525); 
        kon[48] = new Konstanty("kp", 9.80665, 525); 
        kon[49] = new Konstanty("dyn", 0.00001, 525);  
        kon[50] = new Konstanty("Pas", 1, 533); 
        kon[51] = new Konstanty("miPas", 0.001, 533); 
        kon[52] = new Konstanty("cp", 0.001, 533);  
        kon[53] = new Konstanty("deg", 1, 5444); 
        kon[54] = new Konstanty("ft", 0.3048, 5);  
        kon[55] = new Konstanty("in", 0.0254, 5); 
        kon[56] = new Konstanty("yd", 0.9144, 5); 
        kon[57] = new Konstanty("sqin", 0.00064516, 6); 
        kon[58] = new Konstanty("sqft", 0.0929457, 6); 
        kon[59] = new Konstanty("galUS", 0.003785, 7); 
        kon[60] = new Konstanty("galGB", 0.0045435, 7);  
        kon[61] = new Konstanty("hr", 3600, 54);  
        kon[62] = new Konstanty("sec", 1, 54); 
        kon[63] = new Konstanty("mol", 1, 544444L);  
        kon[64] = new Konstanty("kmol", 1000, 544444L); 
        kon[65] = new Konstanty("mip", 0.0000001, 533); 
        kon[66] = new Konstanty("lb", 0.4536, 544);
        kon[67] = new Konstanty("oz", 0.02835, 544); 
        kon[68] = new Konstanty("lbf", 4.4482, 544); 
        kon[69] = new Konstanty("pdl", 0.13826, 525);  
        kon[70] = new Konstanty("BTU", 1055.1, 526); 
        kon[71] = new Konstanty("psia", 6895, 523);  
        kon[72] = new Konstanty("ml", 1e-6, 7);   
        kon[73] = new Konstanty("inHg", 3386.4, 523); 
        kon[74] = new Konstanty("mmHg", 133.322, 523);
        kon[75] = new Konstanty("y", 31557600, 54);  
        kon[76] = new Konstanty("h", 3600, 54); 
        kon[77] = new Konstanty("mile", 1609.3, 5); 
        kon[78] = new Konstanty("x", 1, 54444444L); 
        kon[79] = new Konstanty("A", 1, 54444);  
        kon[80] = new Konstanty("mA", 0.001, 54444L); 
        kon[81] = new Konstanty("uA", 0.000001, 54444L);  
        kon[82] = new Konstanty("kA", 1000, 54444L);  
        kon[83] = new Konstanty("V", 1, 34516); 
        kon[84] = new Konstanty("mV", 0.001, 34516); 
        kon[85] = new Konstanty("uV", 0.000001, 34516L); 
        kon[86] = new Konstanty("kV", 1000, 34516L); 
        kon[87] = new Konstanty("Ohm", 1, 24516);   
        kon[88] = new Konstanty("kOhm", 1000, 24516); 
        kon[89] = new Konstanty("MOhm", 1e6, 24516); 
        kon[90] = new Konstanty("mi", 1609.3, 5);  
        kon[91] = new Konstanty("°F", 0.555555556, 5444); 
        kon[92] = new Konstanty("°C", 1, 5444); 
        kon[93] = new Konstanty("atm", 101330, 523);          
        kon[94] = new Konstanty("cP", 1000, 533);          
        kon[95] = new Konstanty("cuft", 0.028316846, 7);          
        kon[96] = new Konstanty("cuin", 1.6387064E-5, 7);          
        kon[97] = new Konstanty("at", 1.01325e5, 523);          
        kon[97] = new Konstanty("ozf", 0.278, 525);          
        kon[98] = new Konstanty("pdl", 0.138255, 525);          
        kon[99] = new Konstanty("verst", 1066.78, 5);          
        kon[100] = new Konstanty("HP", 746, 516);          
        kon[101] = new Konstanty("erg", 1e-7, 526);          
        kon[102] = new Konstanty("psi", 6895, 523); 
        kon[103] = new Konstanty("galUK", 0.0045435, 7);  
        kon[104] = new Konstanty("grain", 6.480e-5, 544);  
        kon[105] = new Konstanty("pintUK", 5.683e-4, 7);  
        kon[106] = new Konstanty("acre", 4047, 6);  
        kon[107] = new Konstanty("eV", 1.602e-19, 526);  
        kon[108] = new Konstanty("kn", 0.514, 36);  
        kon[109] = new Konstanty("psf", 47.88, 523);  
        kon[110] = new Konstanty("yr", 31557600, 54);  
        
        nacteno = true;     // příznak načtení převodů
    }
    }
/**
 * Vrací chybový stav: 0-vše v pořádku); 1-nekonzistentní jednotky ); 2-neznámý rozměr
 * @return 
 */
    public int getChyba() {
            return chyba;
    }
    /**
     * Vrací celkový typ rozměru Z
     * @return 
     */
    public long getRozmerZ() {
            return typy[0];
    }
     /**
     * Vrací celkový typ rozměru DO
     * @return 
     */
    public long getRozmerDo() {
            return typy[1];
    }
    /**
     * Vrací pole typu Konstanty s převody
     * @return 
     */
    public static Konstanty[] getKon() {
        return kon;
    }
    /**
     * Vrací i-tý prvek pčřevodů kon
     * @param i
     * @return 
     */
    public static Konstanty getKon(int i) {
        return kon[i];
    }
    /**
     * Vrací počet známých převodů
     * @return 
     */
    public static int getnKonst() {
        return nKonst;
    }
        /**
         * Pomocné pro ladění
         * @param args
         * @throws IOException 
         */
        public static void main(String[] args) throws IOException {
            Prevod p = new Prevod();
            double d;
            d = p.hodnota("1,0124 BTU/lb/°F");  // 1,0124 BTU/lb/°F
            System.out.println("klasicky = "+d+" "+((p.txDo == null)? "":p.txDo));
            d = p.hodnota("km/h 333");
            System.out.println("nestd. DO cislo = "+d+" "+((p.txDo == null)? "":p.txDo));
            d = p.hodnota("°C 451 F");
            System.out.println("teploty = "+d+" "+((p.txDo == null)? "":p.txDo));
            d = p.hodnota("1,2 MJ");            
            System.out.println("= "+d+" "+((p.txDo == null)? "":p.txDo)); 
            d = p.hodnota("cP 324.5 miPas");
            System.out.println("= "+d+" "+((p.txDo == null)? "":p.txDo));             
            System.out.println("DO: "+p.hodnotaDo("mi/hr 120 km/h"));
            System.out.println("ST: "+p.hodnotaString("mi/hr 120 km/h"));
            System.out.println("DO: "+p.hodnotaDo("254,28"));
        }
}
