/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package fydat;

import cheminzlib.JDialogProud;
import cheminzlib.Proud;
import cheminzlib.Reakce;
import cheminzlib.Rovnovaha;
import fydatlib.Smes;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.jdom2.JDOMException;

/**
 * Zkušební program pro ladění modulu Rovnováha
 * @author V. Hlubuček
 */
public class ZkRovn {

        public static void main(String[] args) throws IOException, NumerException, JDOMException {
        int n = 5, iTyp;                     // počet složek směsi, koncentrační typ
        double t, tC, p, pom;       // teplota (K, °C), tlak (Pa)
        double[] x ={50,110,200,0,0}, c = new double[n];     // počáteční složení směsi, , koncentrace poč
        Rovnovaha rovn = null;
        Smes mySmes = new Smes("Moje",143,140,141,1, 142);
        Proud myProud = new Proud(33,null,null,"Proud do rovnováhy"); 
        tC = 60;           // kapalina 70;   parní fáze 120
        t = tC + 273.15;   // absolutní teplota 
        p = 101320;
        iTyp = 1;   // 1- koncentrace; 2-parc. tlak; 3-molární zlomek 
        mySmes.zadatSloz(false, x);    // složení hmotově  (true), molárně (false)
        myProud.setHmotPrutok(1.0);    // kapalina
        myProud.setSmes(mySmes);
        myProud.setpVstup(p);   // vstupní tlak (Pa)
        myProud.setpVystup(0.9*p);        
        myProud.settVstup(tC);  // vstupní teplota (°C)
        pom = mySmes.sHust(t, p)/mySmes.sMolHmot();
        switch (Math.abs(iTyp)) {     // podle typu koncentračního údaje
            case 1: break;              // c
            case 2: pom *= 8.314*t; break;  // parc. tlak 
            case 3: pom = 1; break;     // mol x                
        }
        for(int i = 0; i < 4; i++) {
          c[i] = pom * mySmes.getxMol(i);   
        }
        int[] iSlozky = {-140,-141,142,1};
        int[] iStech = {-1,-1,1,2}; // stechiometrické koeficienty reagujících složek
        int[] iKinSloz = {140,141}; // čísla látek z kinetické rovnice
        double[] radSloz = {1.2,0.8};   // řád k složkám kinetické rovnice
        //   ... k0,T0(K),Eakt(J/mol),dH(J/mol),Krovn,TKrovn ...
        Reakce reak = new Reakce(iSlozky, iStech, 2.25e-7, 310, 22000.14, -31210.3, (iTyp !=3)?1e7:3, 60 + 273.15,iTyp,iKinSloz,radSloz);
        List<Reakce> listReakci = new ArrayList<Reakce>();      // seznam reakcí
        listReakci.add(reak);   // přidej reakci
        rovn = new Rovnovaha(listReakci,c,iTyp,myProud);
        rovn.setXxPoc(5000);    // počáteční hodnota rozahu reakce
        rovn.spoctiRovnovahu(iTyp, c, t);  // volání s výpočtem rovnovážného složení do c[], nemění složení proudu
//        rovn.spoctiRovnovahu(); // volání s výpočtem rovnovážného složení do směsi proudu
        myProud.setVysledek(rovn.getReport());
        JDialogProud frmProud = new JDialogProud(null, "Rovnovaha  (Verze " 
                    + rovn.getVERZE() + ")\n", rovn.getPr()); // modálně vyskakovací 
        }

}
