/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package fydatlib;

import fydat.CenterRenderer;
import fydat.CenterRendererSloz;
import fydat.Slozka;
import fydat.TableModelSmes;
import java.awt.Color;
import java.awt.event.KeyEvent;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;
import javax.swing.JTable;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.JTableHeader;
import javax.swing.table.TableColumn;
import javax.swing.table.TableColumnModel;

/**
 * Panel pro zadávání složení vybrané směsi.
 * Panel použijte v uživatelském frame. Po zadání volá metodu posluchače slozeniZadano().
 * Používá ho modální vyskakovací JDialogSlozeni.
 * @author V. Hlubuček
 */
public class JPanelSlozeni extends javax.swing.JPanel {
    
    private Smes mySmes;
    TableModelSmes smesModel = new TableModelSmes();
    List<SlozeniListener> listenerList = new ArrayList();
    
    
    /**
     * Creates new form JPanelSlozeni - konstruktor
     */
    public JPanelSlozeni() {
        initComponents();
        myInit();
    }
/**
 *  Inicializace uživatelských prvků panelu (jTable a pod.)
 */    
    public final void myInit() {
 
        // Formátování tabulky
        jTableSmes.setModel(smesModel);
        JTableHeader header = jTableSmes.getTableHeader();
        header.setBackground(new Color(0xA0CCFF));
//        header.setBackground(Color.red);
        jTableSmes.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
        int vColIndex = 0;
        TableColumn col = jTableSmes.getColumnModel().getColumn(vColIndex);
        int width = 50;
        col.setPreferredWidth(width);
        TableColumn col2 = jTableSmes.getColumnModel().getColumn(1);
        col2.setPreferredWidth(225);
        TableColumn col3 = jTableSmes.getColumnModel().getColumn(2);
        col3.setPreferredWidth(80);
        TableColumnModel tcm = jTableSmes.getColumnModel();
        TableColumn tc = tcm.getColumn(TableModelSmes.COLUMN_CISLO);
        tc.setCellRenderer(new CenterRenderer());
        TableColumnModel tcmSl = jTableSmes.getColumnModel();
        TableColumn tcSl = tcmSl.getColumn(TableModelSmes.COLUMN_SLOZENI);
        tcSl.setCellRenderer(new CenterRendererSloz());
        jTableSmes.getSelectionModel().addListSelectionListener(new ListSelectionListener() {

            public void valueChanged(ListSelectionEvent e) {
                int row = jTableSmes.getSelectedRow();
                if (row != -1) {
                    Object o = jTableSmes.getModel().getValueAt(row, 2);
                    Object o1 = jTableSmes.getModel().getValueAt(row, 0);
                    System.out.println("INDEX:" + e.getLastIndex() + "   c= " + o1 + "   x= " + o);
                    int cislo = Integer.parseInt("" + o1);
//                    zobrazLatku(cislo - 1);
                }
            }
        });
    }
    public void naplnTabSloz() {
        int cLatky;
            //  Zrušení předchozí tabulky
            smesModel.removeAllSlozka();
//            jTableSmes.repaint();
            
            for (int i = 0; i < mySmes.getnSloz(); i++) {
//                cLatky = mySmes.getLatka(i).getCislo(); // dává jen pořadové číslo !!!!
                cLatky = mySmes.getSlozka(i).getCislo();
                System.out.println("č. látky: "+cLatky);
                smesModel.addSlozka(new Slozka(cLatky,
                        mySmes.getSlozka(i).getNazev(), ""));
            }
            if (jTableSmes.getRowCount() > 0) {
                jTableSmes.getSelectionModel().setSelectionInterval(0, 0);
                jTableSmes.getColumnModel().getSelectionModel().setSelectionInterval(2, 2);
                jTableSmes.requestFocus();
            }          
    }
/**
 *  Poskytne aktuální směs z JPanelSlozeni
 * @return  Smes
 */
    public Smes getSmes() {
        return mySmes;
    }
/**
 * Nastaví aktuální směs pro JPanelSlozeni
 * @param mySmes 
 */
    public void setSmes(Smes mySmes) {
        this.mySmes = mySmes;
    }
  /*
  *  Přidá SlozeniListener do seznamu v JPanelSlozeni
  */   
    public void addSlozeniListener(SlozeniListener l) {
        listenerList.add(l);
    }
    /**
     * Odebere SlozeniListener ze seznamu v JPanelSlozeni
     * @param l 
     */
    public void removeSlozeniListener(SlozeniListener l) {
        listenerList.remove(l);
    }
   
    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jScrollPane4 = new javax.swing.JScrollPane();
        jTableSmes = new javax.swing.JTable();
        jPanel9 = new javax.swing.JPanel();
        jRadioButtonHmot = new javax.swing.JRadioButton();
        jRadioButtonMol = new javax.swing.JRadioButton();
        jLabelInfoSloz = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jButtonSmazSloz = new javax.swing.JButton();
        jLabel10 = new javax.swing.JLabel();
        jTextFieldNazSmesi = new javax.swing.JTextField();
        jButton1 = new javax.swing.JButton();

        jLabel1.setText("Vkládat složení směsi");

        jTableSmes.setModel(new TableModelSmes());
        jScrollPane4.setViewportView(jTableSmes);

        jPanel9.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        jRadioButtonHmot.setSelected(true);
        jRadioButtonHmot.setText("Hmotové zadání složení");
        jRadioButtonHmot.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonHmotActionPerformed(evt);
            }
        });

        jRadioButtonMol.setText("Molární zadání složení");
        jRadioButtonMol.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonMolActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel9Layout = new javax.swing.GroupLayout(jPanel9);
        jPanel9.setLayout(jPanel9Layout);
        jPanel9Layout.setHorizontalGroup(
            jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel9Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jRadioButtonMol)
                    .addComponent(jRadioButtonHmot))
                .addContainerGap(48, Short.MAX_VALUE))
        );
        jPanel9Layout.setVerticalGroup(
            jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel9Layout.createSequentialGroup()
                .addComponent(jRadioButtonHmot)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jRadioButtonMol))
        );

        jLabelInfoSloz.setText("<html>Složení je možno vkládat hmotově nebo molárně (viz volba). Vkládat můžete zlomky nebo i jen poměrové díly. Složení bude následně normalizováno. Jednotlivé již zadané složení smažete pomocí <i>Del</i>.</html>");
        jLabelInfoSloz.setMaximumSize(new java.awt.Dimension(300, 28));
        jLabelInfoSloz.setVerticalTextPosition(javax.swing.SwingConstants.TOP);

        jLabel6.setText("<html>Na spodním panelu se zobrazí  bodové vlastnosti látky na jejímž řádku je fokus. Tlačítko vám umožní dočasnou změnu názvu složky (náhradní látky).</html>");
        jLabel6.setVerticalAlignment(javax.swing.SwingConstants.TOP);

        jButtonSmazSloz.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fydat/data/delete16.png"))); // NOI18N
        jButtonSmazSloz.setText("Smazat celé složení");
        jButtonSmazSloz.setIconTextGap(8);
        jButtonSmazSloz.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonSmazSlozActionPerformed(evt);
            }
        });

        jLabel10.setText("Možno vložit uživatelský název směsi:");

        jButton1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fydat/data/next24.png"))); // NOI18N
        jButton1.setText("Složení zadáno");
        jButton1.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        jButton1.setIconTextGap(6);
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        jButton1.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                jButton1KeyTyped(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jScrollPane4, javax.swing.GroupLayout.PREFERRED_SIZE, 362, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel6, javax.swing.GroupLayout.PREFERRED_SIZE, 293, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabelInfoSloz, javax.swing.GroupLayout.PREFERRED_SIZE, 315, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(76, 76, 76)
                        .addComponent(jPanel9, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jLabel10)
                    .addComponent(jButton1)
                    .addComponent(jButtonSmazSloz)
                    .addComponent(jTextFieldNazSmesi, javax.swing.GroupLayout.PREFERRED_SIZE, 213, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jPanel9, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jLabelInfoSloz, javax.swing.GroupLayout.PREFERRED_SIZE, 72, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel6, javax.swing.GroupLayout.PREFERRED_SIZE, 53, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(jButtonSmazSloz)
                        .addGap(18, 18, 18)
                        .addComponent(jLabel10)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jTextFieldNazSmesi, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(15, 15, 15)
                        .addComponent(jButton1))
                    .addComponent(jScrollPane4, javax.swing.GroupLayout.PREFERRED_SIZE, 320, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(128, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void jRadioButtonHmotActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonHmotActionPerformed
        // hmotové složení
        jRadioButtonMol.setSelected(false);
    }//GEN-LAST:event_jRadioButtonHmotActionPerformed

    private void jRadioButtonMolActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonMolActionPerformed
        // molární složení
        jRadioButtonHmot.setSelected(false);
    }//GEN-LAST:event_jRadioButtonMolActionPerformed

    private void jButtonSmazSlozActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonSmazSlozActionPerformed
        // Smazat celé zadané složení:
        //        listSlozeni.removeAll();
        int i;
        for (i = 0; i < mySmes.getnSloz(); i++) {
            jTableSmes.setValueAt("", i, 2);
        }
        jTableSmes.repaint();
    }//GEN-LAST:event_jButtonSmazSlozActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        // Konec zadávání složení - zadáno
        int i;
        double sum;
        double[] x = new double[mySmes.getnSloz()];
        String s;
        boolean isSlozeni = true;
        //        if (listSlozeni.getItemCount() > 0 && listSlozeni.getItemCount() >= jVyber) {  // bylo zadáno složení
            for (i = 0; i < smesModel.getRowCount(); i++) {
                if (smesModel.getValueAt(i, 2).equals("")) {
                    isSlozeni = false;
                }
            }
            if (isSlozeni) {
                sum = 0;
                for (i = 0; i < smesModel.getRowCount(); i++) {
//                    x[i] = Double.parseDouble((smesModel.getRowCount()).replace(',', '.'));
                    s = (String) smesModel.getValueAt(i, 2);
                    x[i] = Double.parseDouble(s.replace(',', '.'));
                    sum += x[i];
                    System.out.println("" + i + 1 + " : " + x[i]);
                }
                if (sum > 0) {
                    try {
                        mySmes.zadatSloz(jRadioButtonHmot.isSelected(), x);
                    } catch (IOException ex) {
                        Logger.getLogger(JPanelSlozeni.class.getName()).log(Level.SEVERE, null, ex);
                    }
                }
                System.out.println("ze zadání složení");
                SlozeniEvent e = new SlozeniEvent();
                e.setSmes(mySmes);        // načtená směs
                e.setnSloz(mySmes.getnSloz()); // počet složek směsi (optonal)
//                e.setPor(jCisla);   // int[] s čísly složek  (optional)
                e.setVybráno(true);
                for( SlozeniListener listener : listenerList ) {
                    listener.slozeniZadano(e);   // ohlášení akce posluchačům
                }
                
            }

    }//GEN-LAST:event_jButton1ActionPerformed

    private void jButton1KeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jButton1KeyTyped
        // Stisk Enter "Na výběr vlastností":
        if (evt.getKeyChar() == KeyEvent.VK_ENTER) {
            int i;
            boolean isSlozeni = true;
//            if (cinnost == 9 || cinnost == 10) {
//                jTabbedPane1.setSelectedIndex(9);
//                jTextFieldFPpoc.requestFocus();
//                return;
//            }
            for (i = 0; i < smesModel.getRowCount(); i++) {
                if (smesModel.getValueAt(i, 2).equals("")) {
                    isSlozeni = false;
                }
            }
//            if (isSlozeni) {  // bylo zadáno složení
//                vlastnostiNaVyber();
//            } else {
//                JOptionPane.showMessageDialog(this,
//                    "Je třeba nejdříve zadat složení!\nA to pro všechny složky.",
//                    "Zadej složení", JOptionPane.WARNING_MESSAGE);
//            }
        }
    }//GEN-LAST:event_jButton1KeyTyped

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButtonSmazSloz;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabelInfoSloz;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JRadioButton jRadioButtonHmot;
    private javax.swing.JRadioButton jRadioButtonMol;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JTable jTableSmes;
    private javax.swing.JTextField jTextFieldNazSmesi;
    // End of variables declaration//GEN-END:variables
}
