/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package fydatlib;

import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;
import org.jdom2.JDOMException;

/**
 * Zkušební ladicí program na vyzkoušení interaktivního zadávání směsi
 * @author V. Hlubuček
 */
public final class ZkJFrame extends javax.swing.JFrame implements SlozkyListener, SlozeniListener {
    int nSloz;
    static boolean lookNimbus = false;      // nastavuje vzhled aplikace
    Smes mySmes;
    
    /**
     * Creates new form ZkJFrame - konstruktor
     */
    public ZkJFrame() throws IOException {
        initComponents();
        myInit();
    }
/*
 *  Reakce na Slozkylistener z JPanelSlozky  umístěného přímo v hlavním GUI 
 *  v e vrací Smes, nSloz a pole s čísly složek směsi (stačí jen směs)
 */    
    public void slozkyZadany(SlozkyEvent e) {
//        mySmes = jPanelSlozky1.getSm();
        if (!e.vybrano) return;
        mySmes = e.getSmes();
        nSloz = e.getnSloz();
        try {
            vypocet();  // hned údaje použije
            System.out.println("* Vypočteno z ZkFrame jPanelSlozky1 !!!!");
        } catch (JDOMException ex) {
            Logger.getLogger(JPanelSlozKom.class.getName()).log(Level.SEVERE, null, ex);                        
        } catch (IOException ex) {
            Logger.getLogger(ZkJFrame.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
    
/*
 *  Reakce na Slozenilistener z JPanelSlozeni  umístěného přímo v hlavním GUI 
 *  v e vrací Smes, nSloz a pole s čísly složek směsi (stačí jen směs)
 */    
    public void slozeniZadano(SlozeniEvent e) {
//        mySmes = jPanelSlozky1.getSm();
        if (!e.vybráno) return;
        mySmes = e.getSmes();
        nSloz = e.getnSloz();
        try {
            vypocet();  // hned údaje použije
            System.out.println("* Vypočteno z ZkFrame jPanelSlozeni1 !!!!");
        } catch (JDOMException ex) {
            Logger.getLogger(JPanelSlozKom.class.getName()).log(Level.SEVERE, null, ex);                        
        } catch (IOException ex) {
            Logger.getLogger(ZkJFrame.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    
    public void myInit() {
//        if (jCheckBoxNimbus.isSelected()) {
//            lookNimbus = true;
//            initComponents();
//        }
        jPanelSlozky1.addSlozkyListener(this);
        jPanelSlozeni1.addSlozeniListener(this);
        jPanelSlozeni1.setSmes(mySmes);   // nastaví již definovanou směs
                
    }
    
    public void vypocet() throws IOException, JDOMException {

        double t, tC, p;       // teplota (K, °C), tlak (Pa)
        double[] x = new double[20];
//        Smes mySmes = new Smes("Moje",1,140,141); // přímé zadání
        if (mySmes == null) return;
        if (mySmes.getnSloz() == 0 ) {
            JOptionPane.showMessageDialog(this,
                    "Nebyla zadána žádná reálná směs! Počet složek nula.",
                    "Výpočet", JOptionPane.WARNING_MESSAGE); 
            return;
        }
        tC=100;  t=tC+273.15;   // teplota
        p=300000;               // tlak (Pa)
        try {
            if (mySmes.getxMol(1) > 0) { }// jdi dál 
        }
        catch (NullPointerException e) {
               // dosad  = 1
            for (int i=0; i < mySmes.getnSloz(); i++) {     // složení
                x[i] = 1;
        } 
          mySmes.zadatSloz(true, x);  // zahrne zadané složení (hmotově)
//          mySmes.slozToMol(x);    // převod na molární zlomky
//          mySmes.slozToHmot(x);    // převod na hmotové zlomky
        }        
        
        System.out.println("Soubor dat: "+Latka.souborDat);
        System.out.format("M.v.: %-8.6f%n",Latka.getLatka(1).getMolHmot()); // Mv. čisté látky(1)
        for (int i=0; i<mySmes.getnSloz(); i++) {
            System.out.format("mySmes %-3d %-20s : %7.5f  %7.5f%n",i+1
                    ,mySmes.getSlozky().get(i).getNazev(),mySmes.getxMol(i),mySmes.getxHmot(i));  // různé zp. sl.
        }
//        System.out.println("mySmes 2: "+mySmes.slozky.get(1).getNazev());
//        System.out.println("mySmes 3: "+mySmes.slozky.get(2).getNazev());
        System.out.format("M.v.: %-8.6f%n",mySmes.sMolHmot());
        System.out.format("CpLW: %-10.5G%n",mySmes.sCpLW(t));
        System.out.format("CpGW: %-10.5G%n",mySmes.sCpGW(t));
        System.out.format("VodL: %-10.5G%n",mySmes.sVodL(t));
        System.out.format("VodG: %-10.5G%n",mySmes.sVodG(t));
        System.out.format("HustL: %-10.5G%n",mySmes.sHustL(t));
        System.out.format("Tenze: %-10.5G%n",mySmes.sTenze(t));
        System.out.format("dHvW: %-10.5G%n",mySmes.sdHvW(t));
        System.out.format("Sigma: %-10.5G%n",mySmes.sSigma(t));
        System.out.format("ViskG: %-10.5G%n",mySmes.sViskG(t));
        System.out.format("rViskG: %-10.5G%n",mySmes.srViskG(t,p));
        System.out.format("ViskL: %-10.5G%n",mySmes.sViskL(t));
        System.out.format("rHustGW: %-10.5G%n",mySmes.srHustGW(t,p));
        System.out.format("HustGW: %-10.5G%n",mySmes.sHustGW(t,p));
        System.out.format("rHGW: %-10.5G%n",mySmes.srHGW(t,p));
        System.out.format("rUGW: %-10.5G%n",mySmes.srUGW(t,p));
        System.out.format("rSGW: %-10.5G%n",mySmes.srSGW(t,p));
        System.out.format("rCpGW: %-10.5G%n",mySmes.srCpGW(t,p));
        System.out.format("Kapa: %-10.5G%n",mySmes.sKapa(t,p));
        System.out.format("JTcoef: %-10.5G%n",mySmes.sJTcoef(t,p));
        System.out.format("LnFug: %-10.5G%n",mySmes.sLnFug(t,p));
        System.out.format("RALAG: %-10.5G%n",mySmes.srVodG(t,p));
        System.out.format("HLW: %-10.5G%n",mySmes.sHLW(t));
        System.out.format("SLW: %-10.5G%n",mySmes.sSLW(t));
        System.out.format("PrL: %-10.4f%n",mySmes.sPrL(t));
        System.out.format("PrG: %-10.4f%n",mySmes.sPrG(t,p));
        System.out.format("TRB(°C): %-10.2f%n",mySmes.sTrb(p)-273.15);
        System.out.format("TBV(°C): %-10.2f%n",mySmes.sTbv(p)-273.15);
//        for (int i = 0; i<mySmes.getnSloz();i++) {
//          System.out.println("x "+i+" = "+mySmes.getxHmot(i));
//        }
         // pokračovat na složení
        jPanelSlozeni1.setSmes(mySmes);
        jPanelSlozeni1.naplnTabSloz();
        jTabbedPane1.setSelectedIndex(1);               
    }
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel1 = new javax.swing.JPanel();
        jPanelSlozky1 = new fydatlib.JPanelSlozky();
        jPanel2 = new javax.swing.JPanel();
        jPanelSlozeni1 = new fydatlib.JPanelSlozeni();
        jButtonSlozeni = new javax.swing.JButton();
        jButton4 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle(" ZKUŠEBNÍ  pro vyzkoušeení JPanelSlozky a JDialogSlozky");

        jButton1.setText("JDialogSloz");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jButton2.setText("Spustit \"VybratSmes\"");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jButton3.setText("Konec");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jPanelSlozky1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanelSlozky1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(16, Short.MAX_VALUE))
        );

        jTabbedPane1.addTab("Zadej složky", jPanel1);

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanelSlozeni1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(83, Short.MAX_VALUE))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGap(37, 37, 37)
                .addComponent(jPanelSlozeni1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(64, Short.MAX_VALUE))
        );

        jTabbedPane1.addTab("Složení", jPanel2);

        jButtonSlozeni.setText("Zadat složení");
        jButtonSlozeni.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonSlozeniActionPerformed(evt);
            }
        });

        jButton4.setText("JDialogSlozKom");
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 116, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jButton2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jButtonSlozeni)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton4, javax.swing.GroupLayout.PREFERRED_SIZE, 136, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jButton3)
                .addContainerGap())
            .addGroup(layout.createSequentialGroup()
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 813, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton1)
                    .addComponent(jButton2)
                    .addComponent(jButton3)
                    .addComponent(jButtonSlozeni)
                    .addComponent(jButton4))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 629, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
//  Definuje a spouští vyskakovací dialog pro zadání složek směsi výběrem ze seznamu
//  ----------  takto se volá přes JDialogSlozky ------------------------------------
//        JDialogSlozky frmSlozky = new JDialogSlozky(this, "Můj titulek");    // modálně vyskakovací s titulkem
        JDialogSlozky frmSlozky = new JDialogSlozky(this);    // modálně vyskakovací
//        frmSlozky.setVisible(true);  // není třeba, když je to v konstruktoru
//        Smes s = new JDialogSlozky(this).getSmes();  // lze vše i jediným příkazem !!!!
        Smes s = frmSlozky.getSmes();
        System.out.println("s = " + s);
//  ---------------------------------------------------------------------------------        
//      po zadání se řízení předá na následující řádek kodu... např k výpočtu
        mySmes = s;
        try {
            vypocet();
        } catch (JDOMException ex) {
            Logger.getLogger(JPanelSlozKom.class.getName()).log(Level.SEVERE, null, ex);                        
        } catch (IOException ex) {
            Logger.getLogger(ZkJFrame.class.getName()).log(Level.SEVERE, null, ex);
        }

    }//GEN-LAST:event_jButton1ActionPerformed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        // Spuštění přes  třídu VybratSmes (oproti JDialogSmes ušetří jen jeden řádek!)
//  ----------  takto se volá přes VybratSmes  --------------------------------------
        VybratSmes vybrana = new VybratSmes();
//        VybratSmes vybrana = new VybratSmes("Můj titulek pro VybratSmes");
        Smes mojeSmes = vybrana.getMySmes();
//  ---------------------------------------------------------------------------------          
        mySmes = mojeSmes;      // ztotožnění s globální směsí
        System.out.println("VybratSMES: nSloz= "+mojeSmes.getnSloz());
        for (int i=0; i<mojeSmes.getnSloz(); i++) {
            System.out.format("mojeSmes %-3d %-20s č: %-3d %n",i
                    ,mojeSmes.getSlozky().get(i).getNazev(),mySmes.getCislaSlozek()[i]);  
        }        
    }//GEN-LAST:event_jButton2ActionPerformed

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        // KONEC
        System.exit(0);
    }//GEN-LAST:event_jButton3ActionPerformed

    private void jButtonSlozeniActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonSlozeniActionPerformed
        // Zadat složení
        jPanelSlozeni1.setSmes(mySmes);
        jPanelSlozeni1.naplnTabSloz();
        jTabbedPane1.setSelectedIndex(1);
        
    }//GEN-LAST:event_jButtonSlozeniActionPerformed

    private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
//  Definuje a spouští vyskakovací dialog pro zadání složek směsi i složení
//  ----------  takto se volá přes JDialogSlozkyKom ------------------------------------
//        JDialogSlozky frmSlozky = new JDialogSlozky(this, "Můj titulek");    // modálně vyskakovací s titulkem
        JDialogSlozKom frmSlozKom = new JDialogSlozKom(this,"Moje SlozKom");    // modálně vyskakovací
//        frmSlozKom.setVisible(true);  // není třeba, když je to v konstruktoru
//        Smes s = new JDialogSlozKom(this).getSmes();  // lze vše i jediným příkazem !!!!
        Smes s = frmSlozKom.getSmes();
        System.out.println("s = " + s);
//  ---------------------------------------------------------------------------------        
//      po zadání se řízení předá na následující řádek kodu... např k výpočtu
        mySmes = s;
        try {
            vypocet();
        } catch (JDOMException ex) {
            Logger.getLogger(JPanelSlozKom.class.getName()).log(Level.SEVERE, null, ex);                        
        } catch (IOException ex) {
            Logger.getLogger(ZkJFrame.class.getName()).log(Level.SEVERE, null, ex);
        }
        
    }//GEN-LAST:event_jButton4ActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        if (lookNimbus) {
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(ZkJFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(ZkJFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(ZkJFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(ZkJFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        }    
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                try {
                    new ZkJFrame().setVisible(true);
                } catch (IOException ex) {
                    Logger.getLogger(ZkJFrame.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JButton jButtonSlozeni;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private fydatlib.JPanelSlozeni jPanelSlozeni1;
    private fydatlib.JPanelSlozky jPanelSlozky1;
    private javax.swing.JTabbedPane jTabbedPane1;
    // End of variables declaration//GEN-END:variables
}
